#include "ioat91sam7x256.h"
#include "system.h"
#include "lcd.h"
#include "bits.h"

//#include "usart.h"
//#include "mmc.h"
//#include "string.h"
//#include "adc.h"



//MAIN POINTER
AT91PS_PIO    m_pPioA  = AT91C_BASE_PIOA;
AT91PS_PIO    m_pPioB  = AT91C_BASE_PIOB;
AT91PS_PMC    m_pPMC   = AT91C_BASE_PMC;
AT91PS_USART  m_pUSART = AT91C_BASE_US0;
AT91PS_PDC    m_pPDC   = AT91C_BASE_PDC_US0;
AT91PS_MC     m_pMC    = AT91C_BASE_MC;
AT91PS_AIC    m_pAic   = AT91C_BASE_AIC;
AT91PS_SYS    m_pSys   = AT91C_BASE_SYS;
AT91PS_ADC    m_pADC   = AT91C_BASE_ADC;
AT91PS_RSTC   m_pRSTC  = AT91C_BASE_RSTC;

#define LCD_RESET_LOW     m_pPioA->PIO_CODR   = BIT2
#define LCD_RESET_HIGH    m_pPioA->PIO_SODR   = BIT2

//it's a simple delay
void Delay (unsigned long a) { while (--a!=0); }

// loop variable
unsigned int i;

int main()
{

  // Freq init
  InitFrec();

  // Init periphery
  InitPeriphery();

  // Init LCD
  InitLCD();


  // Init
  LCD_RESET_LOW;
  Delay(2000);
  LCD_RESET_HIGH;
  //Delay(2000);
  //LCD_RESET_LOW;

  while(1) {
    WriteSpiData(0x55);
    WriteSpiCommand(0x55);
  }

/*
  while(1) {
    WriteSpiData(0xF0);
    WriteSpiCommand(0xF0);
  }
*/

/*
  WriteSpiCommand(DISCTL);  // display control
  WriteSpiData(0x03);
  WriteSpiData(32);
  WriteSpiData(12);
  WriteSpiData(0x00);

  WriteSpiCommand(COMSCN);  // comscn
  WriteSpiData(0x01);

  WriteSpiCommand(OSCON);  // oscon

  WriteSpiCommand(SLPOUT);  // sleep out

  WriteSpiCommand(VOLCTR);  // electronic volume, this is kinda contrast/brightness
  WriteSpiData(5);//ff);       //  this might be different for individual LCDs
  WriteSpiData(0x01);//01);     //

  WriteSpiCommand(PWRCTR);  // power ctrl
  WriteSpiData(0x0f);      //everything on, no external reference resistors

  //delay_ms(100);

  WriteSpiCommand(DISINV);  // display mode


  WriteSpiCommand(DATCTL);  // datctl
  WriteSpiData(0x00);
  WriteSpiData(0);
  WriteSpiData(0x01);
  WriteSpiData(0x00);

  WriteSpiCommand(RGBSET8);   // setup color lookup table
  // color table
  //RED
  WriteSpiData(0);
  WriteSpiData(2);
  WriteSpiData(4);
  WriteSpiData(6);
  WriteSpiData(8);
  WriteSpiData(10);
  WriteSpiData(12);
  WriteSpiData(15);
  // GREEN
  WriteSpiData(0);
  WriteSpiData(2);
  WriteSpiData(4);
  WriteSpiData(6);
  WriteSpiData(8);
  WriteSpiData(10);
  WriteSpiData(12);
  WriteSpiData(15);
  //BLUE
  WriteSpiData(0);
  WriteSpiData(4);
  WriteSpiData(9);
  WriteSpiData(15);


  WriteSpiCommand(NOP);  // nop

  WriteSpiCommand(PASET);   // page start/end ram
  WriteSpiData(2);            // for some reason starts at 2
  WriteSpiData(131);

  WriteSpiCommand(CASET);   // column start/end ram
  WriteSpiData(0);
  WriteSpiData(131);


  WriteSpiCommand(RAMWR);    // write some stuff (background)
  for (i = 0; i < 18000; i++){
    WriteSpiData(28);  // 28 is green
  }


  WriteSpiCommand(DISON);   // display on

  WriteSpiCommand(DISOFF);   // display on

  WriteSpiCommand(DISON);   // display on
  //delay_ms(200);

 for (i = 0; i < 160; i++){   // this loop adjusts the contrast, change the number of iterations to get
   WriteSpiCommand(VOLUP);                // desired contrast.  This might be different for individual LCDs
   //delay_ms(2);
   Delay(2000);
 }
*/


    WriteSpiCommand(DISCTL);  // display control
    WriteSpiData(0x00);
    WriteSpiData(0x1f);
    WriteSpiData(0x0b);

    WriteSpiCommand(COMSCN);        //
    WriteSpiData(0x01);             // Scan 1-80

    WriteSpiCommand(OSCON);         //

    WriteSpiCommand(SLPOUT);        // Sleep out command (must be done before DISPON)


    WriteSpiCommand(VOLCTR);  // electronic volume, this is kinda contrast/brightness
    WriteSpiData(0x5B);      // change this to get brighter or darker start point then use volup/down to adjust
    WriteSpiData(0x03);

    WriteSpiCommand(TMPGRD);  // Temp Gradient
    WriteSpiData(0x01);

    // ???
    // LCD_Set_Resolution(LOW_RES);
    WriteSpiCommand(DATCTL);     // datctl
    WriteSpiData(0x00);          // Param 1  Normal Page address, Normal column, Scan Column dir.
    WriteSpiData(0x04);          // param 2  Set for R-G-B order
    WriteSpiData(0x01);           // param 3  8-bit or 16 bit ?
    // WriteSpiData(0x02);           // param 3  8-bit or 16 bit ?

    WriteSpiCommand(RGBSET8);   // setup color lookup table
// Setup the color lookup table by choosing evenly spaced color values
// for a nice even spread. Blue only has 2 bits, so the spacing is wider
// but still spans 0x00 - 0x0f
// Bit organisation is RRRGGGBB

    WriteSpiCommand(RGBSET8);
    WriteSpiData(0x00);                // RED
    WriteSpiData(0x02);
    WriteSpiData(0x04);
    WriteSpiData(0x06);
    WriteSpiData(0x08);
    WriteSpiData(0x0a);
    WriteSpiData(0x0c);
    WriteSpiData(0x0f);
    WriteSpiData(0x00);                // GREEN
    WriteSpiData(0x02);
    WriteSpiData(0x04);
    WriteSpiData(0x06);
    WriteSpiData(0x08);
    WriteSpiData(0x0a);
    WriteSpiData(0x0c);
    WriteSpiData(0x0f);
    WriteSpiData(0x00);                // BLUE
    WriteSpiData(0x04);
    WriteSpiData(0x09);
    WriteSpiData(0x0f);

    WriteSpiCommand(NOP);                                // Data Sheet recomends you send this from time to time

    WriteSpiCommand(DISINV);

    //LCD_Fill(0,0,132,132,Black);                            // clear screen
    // ctl_timeout_wait(ctl_get_current_time() + 100);         // data sheet says to wait 100ms here

    // Go to x,y -> 0,0
    WriteSpiCommand(PASET);                             // page start/end ram
    WriteSpiData(0);                                     // Start Page to display to
    WriteSpiData(131);                                   // End Page to display to
                                                            //
    WriteSpiCommand(CASET);                             // column start/end ram
    WriteSpiData(0);                                     // Start Column to display to
    WriteSpiData(131);

    WriteSpiCommand(RAMWR);                  // Write to display
                                                //
    for (i=0; i<100; i++)                     // pixels per line
    {                                           //
        WriteSpiData(50);                       //
    }                                           //
                                                //
    WriteSpiCommand(NOP);                    // End



    WriteSpiCommand(PWRCTR);                             // power ctrl
    WriteSpiData(0x0f);                                  //everything on

    // ctl_timeout_wait(ctl_get_current_time() + 100);         // data sheet says to wait 100ms here

    WriteSpiCommand(NOP);                                // Data Sheet recomends you send this from time to time
    WriteSpiCommand(DISON);                             // Turn Display ON



  // loop forewer
  while(1) {

    // check button SW1
    if(!((m_pPioB->PIO_PDSR) & BIT24)) {
        Backlight(BKLGHT_LCD_ON);
    }

    // check button SW2
    if(!((m_pPioB->PIO_PDSR) & BIT25)) {
        Backlight(BKLGHT_LCD_OFF);
    }

  }

}
